apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
{% if do_s3 %}
    backups.opsperator.io/driver: s3
{% else %}
    backups.opsperator.io/driver: ssh
{% endif %}
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
{% if not do_s3 %}
    backups.opsperator.io/secret: backups-{{ nextcloud_name }}
    backups.opsperator.io/service: backups-{{ nextcloud_name }}
{% elif nextcloud_s3_flavor == 'minio' %}
    backups.opsperator.io/secret: {{ minio_name | default('s3') }}-nextcloud
    backups.opsperator.io/service: {{ minio_name | default('s3') }}-client
{% elif nextcloud_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
    backups.opsperator.io/secret: {{ rgw_name | default('s3') }}-nextcloud
    backups.opsperator.io/service: {{ rgw_name | default('s3') }}
{% endif %}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ nextcloud_name }}
  name: {{ nextcloud_name }}
  namespace: {{ namespace }}
spec:
{% if has_dc.resources | length == 0 %}
  replicas: 1
{% elif not do_hpa %}
  replicas: {{ nextcloud_replicas }}
{% endif %}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ nextcloud_name }}
  strategy:
{% if do_s3 %}
    type: RollingUpdate
{% else %}
    type: Recreate
{% endif %}
{% else %}
    name: {{ nextcloud_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
{% if do_s3 %}
    rollingParams:
      timeoutSeconds: 1200
    type: Rolling
{% else %}
    recreateParams:
      timeoutSeconds: 1200
    type: Recreate
{% endif %}
{% endif %}
  template:
    metadata:
      labels:
        name: {{ nextcloud_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ nextcloud_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ nextcloud_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
{% if do_s3 %}
      automountServiceAccountToken: true
{% else %}
      automountServiceAccountToken: false
{% endif %}
      containers:
      - env:
        - name: APACHE_DOMAIN
          value: {{ nextcloud_fqdn }}
        - name: APACHE_HTTP_PORT
          value: "8080"
        - name: APPS_CACHE
{% if nextcloudappscache_api_public | default(False) %}
          value: "{{ nextcloudappscache_api_public }}"
{% elif nextcloudappscache_api_address | default(False) %}
          value: "{{ nextcloudappscache_api_address }}"
{% else %}
          value: "https://apps.nextcloud.com"
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: DO_ADMINAUDIT
          value: "{% if do_adminaudit %}true{% else %}false{% endif %}"
        - name: DO_DRAW
          value: "{% if do_draw %}true{% else %}false{% endif %}"
        - name: DO_FULLTEXTSEARCH
          value: "{% if do_fulltextsearch %}true{% else %}false{% endif %}"
        - name: DO_GLOBALSITESELECTOR
          value: "{% if do_globalsiteselector %}true{% else %}false{% endif %}"
        - name: DO_GROUPFOLDERS
          value: "{% if do_groupfolders %}true{% else %}false{% endif %}"
        - name: DO_IMPERSONATE
          value: "{% if do_impersonate %}true{% else %}false{% endif %}"
        - name: DO_MATOMO
          value: "{% if do_matomo %}true{% else %}false{% endif %}"
        - name: DO_MDED
          value: "{% if do_markdown %}true{% else %}false{% endif %}"
        - name: DO_LOOL
          value: "{% if lool_api_public | default(False) %}true{% else %}false{% endif %}"
        - name: DO_PASSWORDS
          value: "{% if do_passwords %}true{% else %}false{% endif %}"
        - name: DO_PRIVACY
          value: "{% if do_privacy %}true{% else %}false{% endif %}"
        - name: DO_QUOTAWARNING
          value: "{% if do_quotawarning %}true{% else %}false{% endif %}"
        - name: DO_REASONS
          value: "false"
        - name: DO_SOCIALS
          value: "false"
        - name: DRAW_DOMAIN
{% if do_draw %}
{% if draw_api_address | default(False) %}
          value: {{ draw_api_address | urlsplit('hostname') }}
{% else %}
          value: embed.diagrams.net
{% endif %}
{% else %}
          value: ""
{% endif %}
        - name: ELASTICSEARCH_HOST
{% if do_fulltextsearch %}
{% if fulltextsearch_storage_flavor in [ 'elastic', 'elasticsearch' ] %}
          value: {{ elasticsearch_name }}-client.{{ namespace }}.svc.{{ cluster_domain }}
{% else %}
          value: {{ opensearch_name }}-client.{{ namespace }}.svc.{{ cluster_domain }}
{% endif %}
        - name: ELASTICSEARCH_INDEX
          value: nextcloud
        - name: ELASTICSEARCH_PORT
          value: "9200"
        - name: ELASTICSEARCH_PROTO
          value: http
{% else %}
          value: ""
        - name: ELASTICSEARCH_INDEX
          value: ""
        - name: ELASTICSEARCH_PORT
          value: ""
        - name: ELASTICSEARCH_PROTO
          value: ""
{% endif %}
        - name: HTTP_PROXY
{% if proxy_host | default(False) %}
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: HTTPS_PROXY
          value: http://{{ proxy_host }}:{{ proxy_port | default('3128') }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% elif squid_address is defined %}
          value: {{ squid_address }}
        - name: HTTPS_PROXY
          value: {{ squid_address }}
        - name: NO_PROXY
          value: "{% if (no_proxy | default([])) | length > 0 %}{{ no_proxy | join(',') }},{% endif %}.{{ namespace }}.svc.{{ cluster_domain }},.{{ namespace }}.svc,.{{ namespace }},.svc.{{ cluster_domain }},.svc,.{{ cluster_domain }},.local,.{{ root_domain }}"
{% else %}
          value: ""
        - name: HTTPS_PROXY
          value: ""
        - name: NO_PROXY
          value: ""
{% endif %}
        - name: LLNG_PROTO
{% if do_lemon %}
          value: {{ lemon_portal | urlsplit('scheme') }}
        - name: LLNG_SSO_DOMAIN
          value: {{ lemon_portal | urlsplit('hostname') }}
{% else %}
          value: ""
        - name: LLNG_SSO_DOMAIN
          value: ""
{% endif %}
        - name: LOOL_ENDPOINT
{% if lool_api_public | default(False) %}
          value: {{ lool_api_public | urlsplit('hostname') }}
        - name: LOOL_PORT
{% if lool_api_public | urlsplit('scheme') == 'https' %}
          value: "{{ lool_api_public | urlsplit('port') | default(443) }}"
{% else %}
          value: "{{ lool_api_public | urlsplit('port') | default(80) }}"
{% endif %}
        - name: LOOL_PROTO
          value: {{ lool_api_public | urlsplit('scheme') }}
        - name: LOOL_WS_PROTO
{% if lool_api_public | urlsplit('scheme') == 'https' %}
          value: wss
{% else %}
          value: ws
{% endif %}
{% else %}
          value: ""
        - name: LOOL_PORT
          value: ""
        - name: LOOL_PROTO
          value: ""
        - name: LOOL_WS_PROTO
          value: ""
{% endif %}
        - name: MATOMO_SITE_ID
{% if do_matomo and matomo_api_public is defined %}
          value: "{{ nextcloud_matomo_site_id }}"
        - name: MATOMO_URL
          value: {{ matomo_api_public }}
{% else %}
          value: ""
        - name: MATOMO_URL
          value: ""
{% endif %}
{% if nextcloud_db_type == 'percona' %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ ncpc_name }}
        - name: MYSQL_HOST
          value: {{ ncpc_name }}-client
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ ncpc_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ ncpc_name }}
{% elif nextcloud_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ ncms_name }}
        - name: MYSQL_HOST
          value: {{ ncms_name }}
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ ncms_name }}
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ ncms_name }}
{% else %}
        - name: MYSQL_PASSWORD
          value: ""
{% endif %}
        - name: NEXTCLOUD_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ nextcloud_name }}
        - name: NEXTCLOUD_ADMIN_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ nextcloud_name }}
        - name: NEXTCLOUD_CONFIGMAP_NAME
{% if do_s3 %}
          value: {{ nextcloud_name }}
{% else %}
          value: ""
{% endif %}
        - name: NEXTCLOUD_CRON_INTERVAL
          value: sidecar
        - name: NEXTCLOUD_DATA_LOCATION
          value: {{ nextcloud_data_location }}
        - name: NEXTCLOUD_K8S_NAMESPACE
{% if do_s3 %}
          valueFrom:
            fieldRef:
              fieldPath: metadata.namespace
{% else %}
          value: ""
{% endif %}
        - name: NEXTCLOUD_LOOKUP_HOST
{% if do_globalsiteselector %}
          value: {{ (nextcloudlookupserver_pub_address | default('lookup.demo.lan')) | urlsplit('hostname') }}
{% else %}
          value: ""
{% endif %}
{% if do_ldap %}
        - name: OPENLDAP_BASE
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=nextcloud,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: nextcloud-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ nextcloud_ldap_user_objectclass }}
{% endif %}
{% else %}
        - name: OPENLDAP_BASE
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USERS_OBJECTCLASS
          value: ""
{% endif %}
        - name: OTHER_TRUSTED_DOMAINS
          value: {{ nextcloud_name }},{{ nextcloud_name }}.{{ namespace }},{{ nextcloud_name }}.{{ namespace }}.svc,{{ nextcloud_name }}.{{ namespace }}.{{ cluster_domain }}
{% if nextcloud_db_type == 'postgres' %}
        - name: POSTGRES_DB
          valueFrom:
            secretKeyRef:
              key: database-name
              name: {{ ncpg_name }}
        - name: POSTGRES_HOST
          value: {{ ncpg_name }}
        - name: POSTGRES_PASSWORD
          valueFrom:
            secretKeyRef:
              key: database-password
              name: {{ ncpg_name }}
        - name: POSTGRES_USER
          valueFrom:
            secretKeyRef:
              key: database-user
              name: {{ ncpg_name }}
{% else %}
        - name: POSTGRES_PASSWORD
          value: ""
{% endif %}
        - name: PHP_MAX_EXECUTION_TIME
          value: "{{ nextcloud_php_max_execution_time }}"
        - name: PHP_MAX_FILE_UPLOADS
          value: "{{ nextcloud_php_max_file_uploads }}"
        - name: PHP_MAX_POST_SIZE
          value: "{{ nextcloud_php_max_post_size }}"
        - name: PHP_MAX_UPLOAD_FILESIZE
          value: "{{ nextcloud_php_max_upload_filesize }}"
        - name: PHP_MEMORY_LIMIT
          value: {{ nextcloud_php_memory_limit }}
        - name: PUBLIC_PROTO
          value: https
{% if do_s3 %}
        - name: S3_ACCESS_KEY
{% if nextcloud_s3_flavor == 'minio' %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ minio_name | default('s3') }}-nextcloud
        - name: S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ minio_name | default('s3') }}-nextcloud
        - name: S3_HOST
          value: {{ minio_api_address | urlsplit('hostname') }}
        - name: S3_PORT
          value: "{{ minio_api_address | urlsplit('port') }}"
        - name: S3_REGION
          valueFrom:
            secretKeyRef:
              key: region
              name: {{ minio_name | default('s3') }}-nextcloud
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ minio_name | default('s3') }}-nextcloud
{% elif nextcloud_s3_flavor in [ 'ceph', 'rados', 'radosgw' ] %}
          valueFrom:
            secretKeyRef:
              key: access-key
              name: {{ rgw_name | default('s3') }}-nextcloud
        - name: S3_BUCKET
          valueFrom:
            secretKeyRef:
              key: bucket
              name: {{ rgw_name | default('s3') }}-nextcloud
        - name: S3_HOST
          value: {{ radosgw_api_address | urlsplit('hostname') }}
        - name: S3_PORT
          value: "{{ radosgw_api_address | urlsplit('port') }}"
        - name: S3_SECRET_KEY
          valueFrom:
            secretKeyRef:
              key: secret-key
              name: {{ rgw_name | default('s3') }}-nextcloud
{% else %}
          value: ""
        - name: S3_BUCKET
          value: ""
        - name: S3_HOST
          value: ""
        - name: S3_PORT
          value: ""
        - name: S3_SECRET_KEY
          value: ""
{% endif %}
{% endif %}
        - name: SAML_LOCKOUT
          value: "{% if do_lemon %}pleasedo{% endif %}"
        - name: SMTP_HOST
{% if smtp_relay | default(False) %}
          value: {{ smtp_relay }}
        - name: SMTP_PORT
          value: "{{ smtp_port | default('25') }}"
        - name: SMTP_PROTO
          value: smtp
{% elif smtps_address | default(False) %}
          value: {{ smtps_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtps_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtps
{% elif smtp_address | default(False) %}
          value: {{ smtp_address | urlsplit('hostname') }}
        - name: SMTP_PORT
          value: "{{ smtp_address | urlsplit('port') }}"
        - name: SMTP_PROTO
          value: smtp
{% else %}
          value: ""
        - name: SMTP_PORT
          value: ""
        - name: SMTP_PROTO
          value: ""
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='nextcloud'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='nextcloud'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ nextcloud_fqdn }}
            path: /robots.txt
            port: 8080
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 5
        name: nextcloud
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            httpHeaders:
            - name: Host
              value: {{ nextcloud_fqdn }}
            path: /robots.txt
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 15
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ nextcloud_cpu_limit }}"
            memory: "{{ nextcloud_memory_limit }}"
          requests:
            cpu: "{{ nextcloud_cpu_request }}"
            memory: "{{ nextcloud_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 39
          initialDelaySeconds: 30
          periodSeconds: 30
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
{% if (do_ldap or do_lemon or smtps_address | default(False) or nextcloudappscache_api_public | default(False) or (do_globalsiteselector and nextcloudlookupserver_pub_address | default(False))) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: apachesites
          subPath: apache
{% if do_ldap or do_lemon %}
        - mountPath: /etc/ldap
          name: ldapconf
{% if do_lemon %}
        - mountPath: /saml
          name: saml
{% endif %}
{% endif %}
        - mountPath: /usr/local/share/ca-certificates
          name: apachesites
          subPath: ca-certificates
{% if do_s3 %}
        - mountPath: /var/k8s
          name: config
{% endif %}
        - mountPath: /var/www/html
          name: data
      - args:
        - -c
        - >
             if test "$DEBUG"; then
                 set -x;
             fi;
             cd /var/www/html;
             while ! test -s ./config/config.php;
             do
                 echo NOTICE: waiting for nextcloud to initialize;
                 sleep 300;
             done;
             echo NOTICE: nextcloud is ready, starting cron loop;
             sleep 300;
             while true;
             do
                 echo Starting on $(date);
                 php ./cron.php;
                 echo Done on $(date);
                 sleep 300;
             done;
             exit 1;
        command:
        - /bin/sh
        env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if do_triggers == False or (opsimages | json_query("[?name=='nextcloud'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='nextcloud'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: job
        resources:
          limits:
            cpu: "{{ nextcloud_job_cpu_limit }}"
            memory: "{{ nextcloud_job_memory_limit }}"
          requests:
            cpu: "{{ nextcloud_job_cpu_request }}"
            memory: "{{ nextcloud_job_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /var/www/html
          name: data
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
{% if do_triggers == False or (opsimages | json_query("[?name=='httpexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
      - args:
        - --addr
        - :9114
        - --timeout
        - {{ prometheus_scrape_timeout }}
        env:
        - name: NEXTCLOUD_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ nextcloud_name }}
        - name: NEXTCLOUD_SERVER
          value: http://{{ nextcloud_name }}:8080
        - name: NEXTCLOUD_USERNAME
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ nextcloud_name }}
{% if do_triggers == False or (opsimages | json_query("[?name=='ncexporter'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='ncexporter'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 39
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /
            port: 9114
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 10
        name: ncexporter
        ports:
        - containerPort: 9114
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 39
          httpGet:
            path: /
            port: 9114
          initialDelaySeconds: 60
          periodSeconds: 30
          timeoutSeconds: 10
{% endif %}
{% endif %}
{% if do_backups and not do_s3 %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: apachesites
          subPath: bkphome
        - mountPath: /var/backup
          name: apachesites
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
      hostAliases:
      - ip: 127.0.0.1
        hostnames:
        - {{ nextcloud_name }}
{% if do_exporters %}
        - stats
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if (rwx_storage | default(False) and rwx_needs_fsgroup | default(False)) or (rwx_storage is not defined and rwo_needs_fsgroup | default(False)) or (k8s_flavor == 'kubernetes' and do_exporters) %}
      securityContext:
{% if rwx_storage | default(False) and rwx_needs_fsgroup | default(False) %}
        fsGroup: {{ rwx_needs_fsgroup }}
{% elif rwx_storage is not defined and rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' and do_exporters %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
{% if do_s3 %}
      serviceAccountName: {{ nextcloud_name }}
{% else %}
      serviceAccountName: default
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ nextcloud_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - emptyDir: {}
        name: apachesites
{% if do_s3 %}
      - configMap:
          name: {{ nextcloud_name }}
        name: config
      - emptyDir: {}
        name: data
{% else %}
      - name: data
        persistentVolumeClaim:
          claimName: {{ nextcloud_name }}
{% endif %}
{% if do_ldap or do_lemon %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% endif %}
{% if (do_ldap or do_lemon or smtps_address | default(False) or nextcloudappscache_api_public | default(False) or (do_globalsiteselector and nextcloudlookupserver_pub_address | default(False))) and k8s_flavor == 'kubernetes' %}

      - name: pkiconf
        projected:
          sources:
{% if do_ldap or do_lemon %}
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if smtps_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: smtp-ca.crt
{% if smtp_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if do_globalsiteselector and nextcloudlookupserver_pub_address | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: nclookup-ca.crt
{% if nextcloudlookupserver_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% if nextcloudappscache_api_public | default(False) %}
          - secret:
              items:
              - key: ca.crt
                path: ncappscache-ca.crt
{% if nextcloudappscache_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
{% if do_lemon %}
      - name: saml
        projected:
          sources:
          - secret:
              items:
              - key: tls.crt
                path: lemon.crt
              name: {{ lemon_saml_secret_name }}
{% endif %}
{% if do_backups and not do_s3 %}
      - name: ssh
        secret:
          secretName: backups-{{ nextcloud_name }}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='nextcloud'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - nextcloud
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='nextcloud'].short"))[0] }}
        namespace: {{ buildns }}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - job
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='nextcloud'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_exporters %}
{% if (opsimages | json_query("[?name=='httpexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - exporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='httpexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if (opsimages | json_query("[?name=='ncexporter'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - ncexporter
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='ncexporter'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% endif %}
{% if do_backups and not do_s3 and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
